property pHttp
property pMem

on beginSprite me
  pMem = member("INFO")
end

on mouseUp me
  data = [:]
  sendAllSprites(#getFormData, data)
  
  tUrl = data["url"]
  -- to do: check if proper URL
  if tUrl starts "http://" then delete char 1 to 7 of tUrl
  
  tmp = explode("/", tUrl, 2)
  tHost = tmp[1]
  if count(tmp)>1 then
    tPath = "/" & tmp[2]
  else
    tPath = "/"
  end if
  
  tmp = explode(":", tHost)
  if count(tmp)>1 then
    tHost = tmp[1]
    tPort = integer(tmp[2])
  else
    tPort = 80
  end if
  
  vars = value(data["var_list"])
  if ilk(vars)<>#propList then vars = [:]
  
  ----------------------------------------------------
  -- HTTP CLASS CODE
  ----------------------------------------------------
  pHttp = script("HTTP").new(tHost, tPort)
  pHttp.setRequestCallback(#show_request, me)
  pHttp.setResponseCallback(#show_result, me)
  -- pHttp.setVerbose(1)
  pHttp.setUserAgent(data["user_agent"])
  
  pHttp.setAccept(data["accept"])
  
  -- to do: check if proper HTTP-Version
  pHttp.setHttpVersion(data["http_version"])
  
  if data["use_auth"]="on" then pHttp.setAuthentication(data["auth_username"], data["auth_password"])
  
  if data["use_proxy"]="on" then 
    if data["use_proxy_auth"]="on" then
      pHttp.setProxy(data["proxy_host"], integer(data["proxy_port"]),data["proxy_username"], data["proxy_password"])
    else
      pHttp.setProxy(data["proxy_host"], integer(data["proxy_port"]))
    end if
  end if
  
  if data["header1"]<>"" and data["header1"] contains ": " then pHttp.addHeaderStr(data["header1"])
  if data["header2"]<>"" and data["header2"] contains ": " then pHttp.addHeaderStr(data["header2"])
  req = pHttp.request(tPath, vars, data["request_type"])
  ----------------------------------------------------
  
  -- reset info text
  pMem.text = ""
  pMem.font = "Courier New"
  pMem.fontsize = 11
  pMem.color = RGB("#000000")
  pMem.fontstyle = [#plain]
  pMem.fixedLineSpace = 0
  
  pMem.text = "Connect to" && tHost && "on port" && tPort & "... "
  
end


----------------------------------------------------
-- REQUEST CALLBACK
----------------------------------------------------
on show_request me, req
  
  r = RETURN
  headlines = []
  
  if not voidP(req["error"]) then
    
    put "failed" & r after pMem
    put req["error"] after pMem
    
  else
    put "OK" & r after pMem
    
    headlines.add(pMem.line.count)
    put "HTTP Request Header" & r after pMem
    
    put req["cmd"] & r after pMem
    repeat with h in req["headers"]
      put h & r after pMem
    end repeat
    
    if req["body"]<>"" then
      headlines.add(pMem.line.count)
      put "HTTP Request Body" & r after pMem
      put cr(req["body"]) & r after pMem
    end if
    
    me.formatHeadlines(headlines)
    
  end if
end

----------------------------------------------------
-- RESPONSE CALLBACK
----------------------------------------------------
on show_result me, res
  r = RETURN
  headlines = []
  
  headlines.add(pMem.line.count)
  put "HTTP Response Header" & r after pMem --& r
  
  put "HTTP Status Code:" && res["status_code"] & r after pMem
  repeat with i = 1 to res["headers"].count
    put res["headers"].getPropAt(i) & ": " & res["headers"][i] & r after pMem
  end repeat
  
  headlines.add(pMem.line.count)
  put "HTTP Response Content (" & _float(res["body"].length/1024.0, 2) && "KB)" & r after pMem
  put cr(res["body"]) after pMem
  pMem.scrolltop = 0
  
  me.formatHeadlines(headlines)
  
  pHttp = 0
end


on formatHeadlines me, headlines
  repeat with n in headlines
    l = pMem.line[n].ref
    l.font = "Verdana"
    l.fontsize = 12
    l.color = RGB("#8B0000")
    l.fontstyle = [#bold]
    l.fixedLineSpace = 42
    l.bottomSpacing = 7
  end repeat
end


